'Rotorsteuerung HAM IV mit Atmel8
'Version 4
'Bugfix: Bremse geht mit 2s Verzgerung zu

$regfile = "m8def.dat"
$crystal = 8000000
$hwstack = 10
$swstack = 10
$framesize = 20

Dim Str1 As String * 3
Dim Str2 As String * 3
Dim Grad As Integer
Dim Grad1 As Integer
Dim Grad3 As Word
Dim Wrd5 As Word
Dim Zeichen As String * 16
Dim Keynr As Byte
Dim N As Byte
Dim I As Byte
Dim Br As Byte
Declare Sub Tastatur

Config Kbd = Portd , Debounce = 40 , Delay = 10
Config Lcdpin = Pin , Db4 = Portb.0 , Db5 = Portb.1 , Db6 = Portb.2 , Db7 = Portb.3 , E = Portb.4 , Rs = Portb.5
Deflcdchar 1 , 7 , 5 , 7 , 32 , 32 , 32 , 32 , 32           '

Links Alias Portc.2
Bremse Alias Portc.3
Rechts Alias Portc.4

Config Links = Output                                       '<--
Config Bremse = Output                                      'Bremse
Config Rechts = Output                                      '-->


Links = 0
Bremse = 0
Rechts = 0

Config Lcd = 16 * 2                                         ' oder 8 * 2

Anf:
Cls
Cursor Off


Config Adc = Single , Prescaler = Auto , Reference = Aref   'Referenzspannung VCC
Start Adc


Wrd5 = Getadc(0)                                            'Sollwert mit Istwert gleichsetzen
Wrd5 = Wrd5 * 10
Wrd5 = Wrd5 / 28                                            'Umrechnen in Grad

Locate 2 , 1
Lcd Wrd5


Drehen:

Do


For I = 1 To 50                                             '50 Messungen und Mittelwert bilden
     Grad = Getadc(0)                                       'um Brummspannung auszugleichen
     Grad3 = Grad + Grad3
     Waitms 3
Next
Grad3 = Grad3 / 140                                         'Umwandeln in Grad

     Locate 1 , 1
     Lcd Grad3 ; Chr(1)                                     'Istwert

     Grad1 = Grad3 - Wrd5                                   'Differenz Ist/Sollwert
     Grad1 = Abs(grad1)                                     'Positiv machen


   If Grad1 < 2 Then                                        'Wenn Differenz < 2, Ziel erreicht
   Locate 1 , 5
   Lcd "*"
   Rechts = 0
   Links = 0
   Wait 2                                                   '2s warten
   Br = 0
   Bremse = 0                                               'Bremse zu
   Call Tastatur                                            'Zur Tastatureingabe springen
   Else                                                     'falls nicht...
   Lcd " " : Bremse = 1 : Br = 1                            '...Bremse auf
   End If

   Locate 1 , 5
   'und Drehen
   Select Case Grad3
    Case Is > Wrd5
    Lcd "<"                                                 'CCW  (<--)
    If Br = 1 Then Links = 1
    Rechts = 0

    Case Is < Wrd5
    Lcd ">"                                                 'CW   (-->)
    Links = 0
    If Br = 1 Then Rechts = 1
   End Select


Loop

End

Sub Tastatur

Zeichen = "123 456 789 *0# "                                'bersetzung Keynr -> gewnschte Werte

N = 0
Wrd5 = 0
Str2 = ""

Do                                                          'Tastatureingabe

   Keynr = Getkbd()

   If Keynr <> 16 Then
      N = N + 1

      Keynr = Keynr + 1

      Str1 = Mid(Zeichen , Keynr , 1)                  'Keynr in Zahlen bersetzen

      Select Case N
        Case 1 To 3 : Str2 = Str2 + Str1                    '3 x Tastatur auslesen
      End Select                                            'und Strings zusammensetzen

      Wrd5 = Val(str2)                                      'aus String -> Zahl

      Waitms 500
      Cls
      Locate 2 , 1
      Lcd "soll " ; Wrd5

      If Keynr = 13 Then Goto Drehen                      '*-Taste
      If Keynr = 15 Then                                  '#-Taste, Abbrechen
      Wrd5 = Grad3

      Goto Anf
      End If
   End If
Loop
End Sub